//+------------------------------------------------------------------+
//|                                                b-TrailingSAR.mqh |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//|    21.11.2005      .           |
//|        start                |
//|  if (UseTrailing) TrailingPositions();                           |
//+------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

extern string _Parameters_Trailing = "-----  ";
extern bool   UseTrailing   = True;    //  
extern double StepParabolic = 0.02;    //  
extern double MaxParabolic  = 0.2;     //  
extern int    Interval      = 5;       //   

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void TrailingPositions() {
  double ldStop;
  double sar1=iSAR(NULL, 0, StepParabolic, MaxParabolic, 1);
  double sar2=iSAR(NULL, 0, StepParabolic, MaxParabolic, 2);
  int    spr=MarketInfo(Symbol(), MODE_SPREAD);
  int    stp=MarketInfo(Symbol(), MODE_STOPLEVEL);

  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
        if (OrderType()==OP_BUY) {
          if (sar2<sar1 && sar1<Bid-stp*Point) ldStop=sar1-Interval*Point;
          else ldStop=OrderStopLoss();
          if (OrderStopLoss()<ldStop) {
            ModifyStopLoss(ldStop, clModifyBuy);
          }
        }
        if (OrderType()==OP_SELL) {
          if (sar2>sar1 && sar1>Ask+stp*Point) ldStop=sar1+(Interval+spr)*Point;
          else ldStop=OrderStopLoss();
          if (OrderStopLoss()>ldStop || OrderStopLoss()==0) {
            ModifyStopLoss(ldStop, clModifySell);
          }
        }
      }
    }
  }
}

//+------------------------------------------------------------------+
//|   StopLoss                                          |
//| :                                                       |
//|   ldStopLoss -  StopLoss                                  |
//|   clModify   -                                    |
//+------------------------------------------------------------------+
void ModifyStopLoss(double ldStop, color clModify) {
  bool   fm;
  double ldOpen=OrderOpenPrice();
  double ldTake=OrderTakeProfit();
  int    err;

  if (IsTradeAllowed()) {
    fm=OrderModify(OrderTicket(), ldOpen, ldStop, ldTake, 0, clModify);
    if (!fm) {
      err=GetLastError();
      Print("Error(",err,") modifying: ",ErrorDescription(err));
    }
    if (fm && UseSound) PlaySound(NameFileSound);
  }
}
//+------------------------------------------------------------------+

